#! /usr/bin/python

#
# SMTPUtilities.py 0.9
#                                                                      
# Copyright (C) 2001,2002 Gerson Kurz (not@p-nand-q.com)
# BSD-Licensed. This is free software, enjoy!

import ShicksSpamTokens

def domainOfAddress(address):
    x = address.find('@')
    if x >= 0:
        return address[x+1:]
    return ""

def splitMailHeader(s):
    result = []
    startindex = -1
    index = 0
    while index < len(s):
        c = s[index]
        if c == ' ':
            # ok, split
            if startindex != -1:
                result.append(s[startindex:index])
                startindex = -1
        elif c == ':':
            # ok, split
            if startindex != -1:
                result.append(s[startindex:index+1])
                startindex = -1
            # ok, split *including* this character
        elif startindex == -1:
            startindex = index
        index += 1
    if startindex != -1:
        result.append(s[startindex:])
    return result

def isSpamSubjectLine(subject):
    subject = subject.lower()
    reload(ShicksSpamTokens)

    weight = float(reduce(lambda x,y:x+y,map(ord,subject)))/len(subject)
    if weight > 128:
        print "Weight %.2f indicates spam mail." % weight
        return 1

    for token_tuple in ShicksSpamTokens.subject_tokens:
        found = 0
        for token in token_tuple:
            if subject.find(token) >= 0:
                found += 1
        if found == len(token_tuple):
            print "Tokens '%s' indicate spam mail." % str(token_tuple).strip()
            return 1

    tokens = subject.split()
    try:
        isdigit = int(tokens[-1])
    except:
        isdigit = 0
    if isdigit:
        print "Integer as last token indicates spam mail."
        return 1

    return 0

def checkSpamMail(lines):
    index = -1
    for line in lines:
        index += 1
        if line.strip() == "": break

        s = line.find(':')
        if s < 0: continue
        
        tokens = (line[:s],line[s:])
        keyword = tokens[0].lower()
        if keyword == 'subject':
            if isSpamSubjectLine(tokens[1]):
                print "SPAM SUBJECT: "+tokens[1].strip()
                new_subject_line = line[:9] + "[SPAM] " + line[9:]
                lines[index] = new_subject_line
            else:
                print "NOT SPAM SUBJECT: "+ tokens[1].strip()
            break
    return lines

def plaintextOnly(lines):
    for index in xrange(len(lines)):
        line = lines[index]
        
        lstart = line.lower()        
        for pattern in ("content-type: application/ms-tnef","content-type: text/html"):
            if lstart[:len(pattern)].lower() == pattern:
                lines[index] = "Content-Type: text/plain" + line[len(pattern):]
    return lines


