#! /usr/bin/python

#
# ShickService.py                                                             
#                                                                      
# Copyright (C) 2001,2002 Gerson Kurz (not@p-nand-q.com)
# BSD-Licensed. This is free software, enjoy!

"""NT-Service for Shicks!

This is a NT Service that starts the POP3 server and the SMTP server automatically. 
Can be configured to start automatically, so you don't need to be logged on to
a NT (or W2K, or perhaps even XP) machine to use e-mail. 

Won't work on the 16-Bit windows series (95,98,ME).

"""


import win32serviceutil, win32service, threading
from win32event import *
from win32file import *
from win32api import *
import ShicksTrace, maildb, os, sys, POP3Server, SMTPServer

class ServerThread(threading.Thread):
    def __init__(self,callback):
        threading.Thread.__init__(self)
        self.callback = callback

    def run(self):
        print "ServerThread() starting."
        self.callback()
        print "ServerThread() terminating."

class ShicksService(win32serviceutil.ServiceFramework):
    _svc_name_ = "shicks"
    _svc_display_name_ = "Shicks! POP3/SMTP Server"
    
    def __init__(self, args):
        win32serviceutil.ServiceFramework.__init__(self, args)
        self.hStopSignal = CreateEvent(None, 0, 0, None)
    
    def SvcStop(self):
        self.ReportServiceStatus(win32service.SERVICE_STOP_PENDING)
        SetEvent(self.hStopSignal)
    
    def SvcDoRun(self):
        self.ReadConfiguration()
        print "Shicks! Service starting POP3 Server"
        POP3 = ServerThread(POP3Server.StartPOP3Server)
        POP3.start()
        SMTP = ServerThread(SMTPServer.StartSMTPServer)
        SMTP.start()
        WaitForSingleObject(self.hStopSignal, INFINITE)
        print "Shicks! Service shutting down"

    def ReadConfiguration(self):
        TRACE_DIRECTORY = maildb.GetConfigSettings("Logfiles",(os.name == "nt") and "c:\\shicks\\log" or "/usr/share/shicks/log")
        try:
            os.makedirs( TRACE_DIRECTORY )
        except:
            pass
        ShicksTrace.TraceFileName = os.path.join(TRACE_DIRECTORY,"shicks.log")
        ShicksTrace.Enable(bOutputToConsole=0)    

if __name__=='__main__':
    win32serviceutil.HandleCommandLine(ShicksService)

